#!/usr/bin/perl
#
use Font::TTF::Font;
require 'getopts.pl';

Getopts("umws");

unless (defined $ARGV[1])
{
    die <<'EOT';

    AddMacCmap [-m] [-u] [-w] [-s] <infile> <outfile>

Strips the Macintosh (-m), Mac Unicode (-u), and/or Windows (-w) cmap from 
a ttf without without touching anything else. Emit no messages if -s.

EOT
}

$f = Font::TTF::Font->open($ARGV[0]) || die "Cannot open TrueType font '$ARGV[0]' for reading.\n";
$o = $f->{'cmap'}->read || die "Font '$ARGV[0]' has no cmap table.\n";

for ($i =$o->{'Num'}-1; $i >= 0; $i--)
{
	
	$c = $o->{'Tables'}[$i];
        $pID=$c->{'Platform'};
        $pEnc=$c->{'Encoding'};
      	#print "$pID => $pEnc\n";
	if ($pID == 1)
	{
                print "Version=",$c->{'Ver'}.',';
                print "Format=",$c->{'Format'};
                print "\n";
		printf "Mac cmap for platformID $pID\n";
	 	#splice @{$o->{'Tables'}}, $i, 1;
	 	#$o->{'Num'}--;
	}
	#if ($pID == 1 and $pEnc == 3) {
	if ($pID == 3 and $pEnc == 1) {
	#	foreach $a (keys(%{$c->{'val'}})) {
        #            #printf "%s\t%s\n",$a,$c->{'val'}{$a};
        #            printf "%04X\t%s\n",$a,$c->{'val'}{$a};
        #        }
		$has_cmap=1;
		$cmap_id=$i;
        }
}

$cmap={};
exit -1 if (!$has_cmap);

$uc = $o->{'Tables'}[$cmap_id];

while(<STDIN>) {
    if (/^0x([0-9A-F]{2,4})\s0x([0-9A-F]{4})\s*/i) {
    	#chomp;
    	#s/\s*[#;].*//o; # remove comments
    	#@work = split /\s/;
        #print $work[0],"\n";
        $d=hex $2;
        $cc=hex $1;
        #print $2,":",$d,"=>";
        if ($uc->{'val'}{$d}) {
            #print $1,":",$uc->{'val'}{$d};
       	    #print "\n";
            $cmap->{$cc}=$uc->{'val'}{$d};
        }
    }
}

$cmap->{0}=$uc->{'val'}{0};
$cmap->{13}=$uc->{'val'}{13};

#
#foreach $c (@{$f->{'cmap'}{'Tables'}})
#
#   $c->{'val'} = $s if ($c->{'Platform'} == 0 || $c->{'Platform'} == 3
#       || ($c->{'Platform'} == 2 && $c->{'Encoding'} == 1));
#   if ($c->{'Platform'} == 3)
#   {
#       $c->{'Encoding'} = 0 if $opt_s;
#       $c->{'Encoding'} = 1 if $opt_u;
#       $has_surr = 1 if $c->{'Encoding'} == 10;
#   }
#

push (@{$f->{'cmap'}{'Tables'}}, {
        'Platform' => 1,
        'Encoding' => 3,
        'Ver' => 0,
        'Format' => 2,
        'val' => $cmap}); # XXX

#printf "Number of cmap tables remaining = %d\n", $o->{'Num'};
$f->out($ARGV[1]);

