#!/bin/bash
#F="graphic:gr:Graphic: ׷: ׷"
#F="pen:ph:Penheulim: 긲: 긲"
#F="gungseo:gs:Gungseo: ü: ü"
#F="bom:bm:Bom: : "
#F="myoungjo:mj:Batang: : "
#F="myoungjo:mjb:BatangBold: :  "
#F="gothic:gt:Dotum: : "
#F="gothic:gtb:DotumBold: :  "
#F="taza:tt:Taza: Ÿ: Ÿ"
#F="pilgi:pg:Pilgi: ʱ: ʱ"
#F="pilgi:pgb:PilgiBold: ʱ:  ʱ"
#F="shinmun:sh:Shinmun: Ź: Ź"
#F="yetgul:yt:Yetgul: : "
#F="pen:pn:Pen: : "

TOPDIR=../..
TOOLDIR=../../tools
ENCDIR=../../enc

check=$(basename $0)
if [ x$check = x"base.sh" ]; then
  echo "Don't direct call it"
  exit -1
fi

X=$(echo $F | cut -d ":" -f 1)
XX0=$(echo $F | cut -d ":" -f 2)

XX1=$(echo $XX0 | cut -c1 |tr 'ju' 'JU')
XX2=$(echo $XX0 | cut -c2- )
XX=$XX1$XX2

XXX=$(echo $F | cut -d ":" -f 3)
FAMILY=$(echo $F | cut -d ":" -f 4)
FONTNAME=$(echo $F | cut -d ":" -f 5)

TT=$(echo $XXX |sed "s/\(Bold\|Light\)$//")
TTT=$(echo $XXX |sed "s/^$TT//")

if [ x$TTT = xBold ]; then
  WEIGHT="Bold";
fi

echo $WEIGHT

# Check *.sfd
if [ ! -f ${XXX}Syllables.sfd ]; then

# need to re generate sfds.
echo "*** $X $XXX"
if [ x$XX1 = xJ ]; then
  cat ${XX}10 |grep '^Width' |cut -d' ' -f2 >${XXX}Width.map
fi

if [ ! -f {$XXX}UHCJamos.sfd ]; then
  perl ${TOOLDIR}/mergejamos $XX Un$XXX >${XXX}UHCJamos.sfd
fi


perl ${TOOLDIR}/ovp2compose < $X$XX0.ovp >${XXX}Syllables.map
if [ x$XX1 = xJ ]; then
perl ${TOOLDIR}/composejhangul 60000 ${XXX}Width.map < ${XXX}Syllables.map >${XXX}Syllables.sfd
else
perl ${TOOLDIR}/composehangul 60000 < ${XXX}Syllables.map >${XXX}Syllables.sfd
fi

fi

if [ ! -f ${XXX}Han.sfd ]; then
# hanja
if [ -f ${XX}20 ]; then
  ${TOOLDIR}/mergehanja.sh $XX > ${XXX}.tmp
  ${TOOLDIR}/sfdenc.pl ${ENCDIR}/hanja.enc < ${XXX}.tmp > ${XXX}Han.sfd
  ${TOOLDIR}/dupsfd <${ENCDIR}/duphanja.enc >>${XXX}Han.sfd
fi
fi

if [ ! -f ${XXX}Sym.sfd ]; then
# symbol
if [ -f ${XX}02 ]; then
  ${TOOLDIR}/mergesymbol.sh $XX >${XXX}.tmp
  #${TOOLDIR}/sfdenc.pl ${ENCDIR}/nsymbol.enc <${XXX}.tmp >${XXX}Sym.sfd
  ${TOOLDIR}/sfdenc.pl sym.enc <${XXX}.tmp >${XXX}Sym.sfd
  ${TOOLDIR}/dupsfd <${ENCDIR}/dup.enc >>${XXX}Sym.sfd
fi

fi

# check missing sfds.
if [ ! -f ${XXX}Sym.sfd ]; then
  touch ${XXX}Sym.sfd
  if [ -f Sym.sfd ]; then
    EXTRA=Sym.sfd
  fi
fi

if [ -f ${XXX}Extra.sfd ]; then
  EXTRA="$EXTRA ${XXX}Extra.sfd"
fi

if [ ! -f ${XXX}Han.sfd ]; then
  touch ${XXX}Han.sfd
fi

if [ ! -f ${XXX}Jamos.sfd ]; then
  touch ${XXX}Jamos.sfd
fi

if [ ! -f ${XXX}Full.sfd ]; then
cat <<EOF > ${XXX}Full.sfd
StartChar: uni3000
Encoding: 12288 12288
Width: 1000
Flags: HW
EndChar
EOF
  touch ${XXX}Full.sfd
fi

if [ -z "$GET_OTF" ]; then

. ${TOOLDIR}/base_ttf

else

. ${TOOLDIR}/base_otf

fi
